/*
 * HashGraph.cpp
 *
 *  Created on: Dec 17, 2009
 *      Author: nricci01
 */

#include "HashGraph.h"
#include <string>
#include <sstream>


HashGraph::HashGraph() {
	// TODO Auto-generated constructor stub

}

HashGraph::~HashGraph() {
	// TODO Auto-generated destructor stub
}


void HashGraph::addEdge(long node1, long node2){

	//if(edgeMap.find(node1) == edgeMap.end()){
	//	edgeMap[node1] = new vector<long>();
	//}

	edgeMap[node1].push_back(node2);
}

bool HashGraph::removeEdge(long node1, long node2){
	vector<long>::iterator it;

	if(edgeMap.find(node1) == edgeMap.end()){
		return false;
	}

	//edgeList = edgeMap[node1];

	it = findEdge(edgeMap[node1], node2);

	if(it == edgeMap[node1].end()){
		return false;
	}

	edgeMap[node1].erase(it);

	return true;
}

bool HashGraph::removeNode(long node){
	map<unsigned long, vector<long> >::iterator it;

	it = edgeMap.find(node);
	if(it == edgeMap.end()){
		return false;
	}
	else{
		edgeMap.erase(it);
	}

}

pair< vector<long>::iterator,vector<long>::iterator >  HashGraph::neighbors(long target) {


	if(edgeMap.find(target) != edgeMap.end() ){
		return pair< vector<long>::iterator,vector<long>::iterator >( edgeMap[target].begin()
		       , edgeMap[target].end()   );
	}


	//This is a convinient thing to return if "target" has no neighbors.
	//It needs to be static, otherwise the iterators no longer make any 
	//sense once this method returns; using them would be undefined.
	static vector<long> nullList;
	return pair< vector<long>::iterator,vector<long>::iterator >(nullList.begin(),nullList.end());
}

vector<long>::iterator HashGraph::findEdge(vector<long>& edgeList, long target){
	vector<long>::iterator it;


	for(it = edgeList.begin(); it != edgeList.end(); it++){
		if(*it == target){
			return it;
		}
	}

	return edgeList.end();
}

string HashGraph::toString() const{
  stringstream ss;

  for (map<unsigned long, vector<long> >::const_iterator it = edgeMap.begin();
						 it != edgeMap.end();
						 it++)
  {
	  ss << it->first  << " :";
	  for(vector<long>::const_iterator jt = it->second.begin(); 
				     jt != it->second.end();
				     jt++)
	  {
	    ss << " " <<  *jt;
	  }
	  ss << endl;
  }

  return ss.str();
}

vector<long> HashGraph::getNodes() const{
  vector<long> node_list;

  for(map<unsigned long, vector<long> >::const_iterator it = edgeMap.begin();
						 it != edgeMap.end();
						 it++)
  {
     node_list.push_back(it->first);
  }


  return node_list;
}

