#include "PointerUpdateRecord.h"
#include "main.h"

#ifdef THREAD_TAG_UPDATES
PointerUpdateRecord::PointerUpdateRecord(unsigned long oldTarget, unsigned long origin, unsigned long newTarget, long thread)
#else
PointerUpdateRecord::PointerUpdateRecord(unsigned long oldTarget, unsigned long origin, unsigned long newTarget)
#endif
{
	this->oldTarget = oldTarget;
	this->origin = origin;
	this->newTarget = newTarget;
	#ifdef THREAD_TAG_UPDATES
	this->thread = thread;
	#endif
}


ostream &PointerUpdateRecord::streamTo(ostream &out){
	if (wantRecord['U']){
		#ifdef THREAD_TAG_UPDATES
		out << "U " << /* this->getTime() << " " << */ oldTarget << " " << origin << " " << newTarget << " " << thread << endl;
		#else
		out << "U " << /* this->getTime() << " " << */ oldTarget << " " << origin << " " << newTarget << endl;
		#endif
	}
}

PointerUpdateRecord::~PointerUpdateRecord()
{
}
